unit main;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, ExtCtrls, ComCtrls,
	myZoomBox;

type
	TForm1 = class(TForm)
		Panel1:      TPanel;
			CheckBox1: TCheckBox;
			CheckBox2: TCheckBox;
			CheckBox3: TCheckBox;
			CheckBox4: TCheckBox;
			Button1:   TButton;
		Panel2:      TPanel;
			TrackBar1: TTrackBar;
		Timer1: TTimer;
    CheckBox5: TCheckBox;
		procedure FormCreate (Sender: TObject);
		procedure TrackBar1Change(Sender: TObject);
		procedure CheckBox1Click (Sender: TObject);
		procedure CheckBox2Click (Sender: TObject);
		procedure CheckBox3Click (Sender: TObject);
		procedure CheckBox4Click (Sender: TObject);
		procedure Button1Click   (Sender: TObject);
		procedure Timer1Timer    (Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
	private
		{ Private 錾 }
		ZoomBox1 : TZoomBox;

		//}邽
		procedure WMEraseBkGnd(var Msg: TMessage); message WM_ERASEBKGND;
		//fBXvC̐ݒ̕ύX߂炦
		procedure WMDisplayChange(var Msg: TMessage); message WM_DISPLAYCHANGE;
		//[y[ĥ
		procedure WMMove(var Msg: TWMMove); message WM_MOVE;
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation
uses
//	myDebug,
	Clipbrd;

{$R *.dfm}


procedure TForm1.WMEraseBkGnd(var Msg: TMessage);
//}邽
begin
//http://hpcgi1.nifty.com/MADIA/DelphiBBS/wwwlng.cgi?print+200504/05040066.txt
	Msg.Result:=0;
end;

procedure TForm1.WMDisplayChange(var Msg: TMessage);
//fBXvCݒ̕ύX𔽉f
begin
	ZoomBox1.DisplayChange(nil);
end;

procedure TForm1.WMMove(var Msg: TWMMove);
begin
	if  (CheckBox5.Checked) then begin
		ZoomBox1.Position := ZoomBox1.ClientOrigin;

		Msg.Result := 0;
	end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
	ZoomBox1                 := TZoomBox.Create(Self);
	ZoomBox1.Align           := alClient;
	ZoomBox1.BGColor         := clBlack;
	ZoomBox1.IsCenter        := CheckBox1.Checked;
	ZoomBox1.IsLayeredWindow := CheckBox2.Checked;
	ZoomBox1.IsMouseCursor   := CheckBox3.Checked;
	ZoomBox1.IsDragPosition  := not(CheckBox4.Checked);
	TrackBar1.Position       := 2;
	TrackBar1Change(nil);
	Timer1.Enabled           := True;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
	//Y[{
	ZoomBox1.Zoom := TrackBar1.Position;
	Self.Caption  := Format('%d{', [ZoomBox1.Zoom]);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
	//Lv`|Cg\ʂ̐^񒆂ɎĂ邩
	ZoomBox1.IsCenter := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
	//C[hEBhELv`邩
	ZoomBox1.IsLayeredWindow := CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
	//}EXJ[\Lv`邩
	ZoomBox1.IsMouseCursor := CheckBox3.Checked;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
	if (CheckBox4.Checked) then begin
		//J[\Ǐ]
		ZoomBox1.IsDragPosition := False;
	end else begin
		//}EXłňړ
		ZoomBox1.IsDragPosition := True;
	end;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
//[y[h
begin
	if (CheckBox5.Checked) then begin
		Self.AlphaBlend         := True;
		CheckBox2.Checked       := False; //C[hEBhE̓Lv`Ȃ
		CheckBox2Click(nil);
		CheckBox4.Checked       := False; //J[\Ǐ]Ȃ
		CheckBox4Click(nil);
		ZoomBox1.IsDragPosition := False; //hbOăLv`|Cg̈ړ͂Ȃ
		ZoomBox1.Position       := ZoomBox1.ClientOrigin;
	end else begin
		Self.AlphaBlend := False;
		CheckBox4Click(nil); //hbOăLv`|Cg̈ړ̃Zbg
	end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
	lpt_Pos : TPoint;
begin
	if (CheckBox4.Checked) then begin
		//J[\Ǐ]
		GetCursorPos(lpt_Pos);        //݂̃}EXJ[\̈ʒu擾
		ZoomBox1.Position := lpt_Pos; //Lv`|CgɃZbg
	end else begin
		//_Lv`A[y[h
		ZoomBox1.Capture;
	end;
end;

procedure TForm1.Button1Click(Sender: TObject);
//Nbv{[hփRs[
var
	l_Bitmap : TBitmap;
begin
	l_Bitmap := TBitmap.Create;
	try
		ZoomBox1.GetBitmap(l_Bitmap);
    Clipboard.Assign(l_Bitmap);
	finally
		l_Bitmap.Free;
	end;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//tH[ړ
begin
	ReleaseCapture;
	SendMessage(Self.Handle, WM_SYSCOMMAND, WPARAM(SC_SIZE or 9), 0);
end;


end.
